/* This file implements the packaging file for our client's kernel modules
   
    Copyright 2002-2005,
   National Instruments Corporation.
   All rights reserved.
   
   originated:  13nov2002
*/


#undef __NO_VERSION__

#define  ___clientKalInterface_c___

/* includes... */

#include <linux/version.h>

#define nNIKAL100_mIsLinux24 (LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,0) && (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)))
#define nNIKAL100_mIsLinux26 (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0) && (LINUX_VERSION_CODE < KERNEL_VERSION(2,7,0)))

#ifdef nNIKAL160_kConfig
   #include <linux/config.h>
#endif
#include <linux/types.h>
#ifdef MODULE
   #if defined(CONFIG_MODVERSIONS) && !defined(MODVERSIONS)
      #define MODVERSIONS
   #endif

   #ifdef MODVERSIONS
      #if nNIKAL100_mIsLinux24
         #include <linux/modversions.h>
      #else
         #include <config/modversions.h>
      #endif
   #endif

   #include <linux/module.h>
   #include <linux/autoconf.h>
#endif

#ifndef ___clientKalInterface_h___
   #include "clientKalInterface.h"
#endif

#ifdef MODULE_LICENSE
   #ifdef nNIKAL100_kCopyrightString
      MODULE_LICENSE(nNIKAL100_kCopyrightString);
   #endif
#endif

#ifdef MODULE_AUTHOR
   #ifdef nNIKAL100_kAuthorString
      MODULE_AUTHOR(nNIKAL100_kAuthorString);
   #endif
#endif

#ifdef MODULE_DESCRIPTION
   #ifdef nNIKAL100_kDescriptionString
      MODULE_DESCRIPTION(nNIKAL100_kDescriptionString);
   #endif
#endif

int init_module(void)
{
   return nNIKAL100_mInsertNamespace(nNIKAL100_namespaceMacro,_ckalcbInitModule)(THIS_MODULE,(THIS_MODULE)->name);
}

void cleanup_module(void)
{
   nNIKAL100_mInsertNamespace(nNIKAL100_namespaceMacro,_ckalcbCleanupModule)(THIS_MODULE);
}

