#!/bin/sh
#
#  generateExportC.sh
#  shell script which parses an -unversioned National Instruments binary
#  to create a c file to define what functions are exported in the kernel.
#  This way only the functions we want will be exported and no others.
#
#   Copyright 2004-2005,
#  National Instruments Corporation.
#  All Rights reserved.
#
#  originated:  10 August 2004
#

. ./Makefile.in

echoUsage()
{
   echo "usage: $0 <input-unversioned.o> <output.export.c>"
}

if [ ! $1 ] || [ ! $2 ]; then
   echoUsage
   exit 1
fi

inputUnversioned=$1
outputExportC=$2

echo "#include <linux/module.h>" > $outputExportC
echo "#ifdef EXPORT_SYMBOL_NOVERS" >> $outputExportC
echo "#define nNIKAL100_mExportSymbol EXPORT_SYMBOL_NOVERS" >> $outputExportC
echo "#else" >> $outputExportC
echo "#define nNIKAL100_mExportSymbol EXPORT_SYMBOL" >> $outputExportC
echo "#endif" >> $outputExportC

for SYMBOL in `$STRINGS $inputUnversioned | $AWK '/^nNIExport_endExportedSymbolsArray$/ {symbol = 0;} {if (symbol==1) print $0} /^nNIExport_beginExportedSymbolsArray$/ {symbol = 1;}' | grep -v _driverEntry$ | grep -v _ckalcbInitModule$ | grep -v _ckalcbCleanupModule$`
do
   if [ -e shortenNISyms.txt ]; then
      shortened=$($GREP -w $SYMBOL shortenNISyms.txt | $AWK '{print $2}')
      if [ "$shortened" != "" ]; then
         SYMBOL=$shortened
      fi
   fi
   echo "extern int $SYMBOL;" >> $outputExportC
   echo "nNIKAL100_mExportSymbol($SYMBOL);" >> $outputExportC
done

