#!/bin/sh
#
#  install.sh
#  Install shell script to install the NI-KAL kernel module to the system
#
#   Copyright 2002-2005,
#  National Instruments Corporation.
#  All Rights reserved.
#
#  originated:  28 October 2002
#

. ./Makefile.in
. ../bin/installerUtility.sh

copyKALModule()
{
   $INSTALL -d $MODPATH/nikal
   $INSTALL -m 0444 $OBJDIR/nikal.$KERNEL_MODULE_EXTENSION $MODPATH/nikal
}

OBJDIR=./objects
if [ ! -e $OBJDIR/nikal.$KERNEL_MODULE_EXTENSION ]; then
   echo "Please make the NI-KAL kernel module before installing."
   exit 1
fi

# must be root
if [ `$ID -ur` != 0 ]; then
   echo "Please run NI-KAL kernel module installer as root"
   exit 1
fi

if configuredForCurrentKernel; then
   # silently unload old nikal if it is installed
   if testKernelDriverLoaded nikal; then
      recursiveUnloadKernelDriver nikal
   fi

   echo -n "Installing NI-KAL (nikal): "

   copyKALModule
   /sbin/depmod -a >/dev/null 2>&1
   if /sbin/modprobe nikal >/dev/null 2>&1 ; then
      echo "done"
   else
      echo "Starting NI-KAL failed!"
      exit 1
   fi
else
   echo -n "Copying NI-KAL (nikal): "
   copyKALModule
   echo "done"
fi

exit 0

