/* This file implements the packaging file for kernel modules that want to
 * interface to the Linux kernel through NI-KAL
   
    Copyright 2004-2005,
   National Instruments Corporation.
   All rights reserved.
   
   originated:  3aug2004
*/

#undef __NO_VERSION__

#define  ___kalInterface_c___

/* includes... */

#include <linux/version.h>

#define nNIKAL100_mIsLinux24 (LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,0) && (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)))
#define nNIKAL100_mIsLinux26 (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0) && (LINUX_VERSION_CODE < KERNEL_VERSION(2,7,0)))

#ifdef nNIKAL160_kConfig
   #include <linux/config.h>
#endif
#include <linux/string.h>
#include <linux/errno.h>
#ifdef MODULE
   #if defined(CONFIG_MODVERSIONS) && !defined(MODVERSIONS)
      #define MODVERSIONS
   #endif

   #ifdef MODVERSIONS
      #if nNIKAL100_mIsLinux24
         #include <linux/modversions.h>
      #else
         #include <config/modversions.h>
      #endif
   #endif

   #include <linux/module.h>
   #include <linux/autoconf.h>
#endif

#ifndef ___nikal_h___
   #include "nikal.h"
#endif

#ifndef ___kalInterface_h___
   #include "kalInterface.h"
#endif

#ifdef MODULE_LICENSE
   #ifdef nNIKAL100_kCopyrightString
      MODULE_LICENSE(nNIKAL100_kCopyrightString);
   #endif
#endif

#ifdef MODULE_AUTHOR
   #ifdef nNIKAL100_kAuthorString
      MODULE_AUTHOR(nNIKAL100_kAuthorString);
   #endif
#endif

#ifdef MODULE_DESCRIPTION
   #ifdef nNIKAL100_kDescriptionString
      MODULE_DESCRIPTION(nNIKAL100_kDescriptionString);
   #endif
#endif

static struct nNIKAL100_tDriver nNIKAL100_mInsertNamespace(nNIKAL100_namespaceMacro,_driver);

int init_module(void)
{
   /* We need to initialize the client first before registering our driver to the
    * kernel. This is to guarantee that we're ready to receive connection from
    * user mode right after we register to the kernel. */
   memset(&nNIKAL100_mInsertNamespace(nNIKAL100_namespaceMacro,_driver), 0, sizeof(struct nNIKAL100_tDriver));
   if (nNIKAL100_mInsertNamespace(nNIKAL100_namespaceMacro,_driverEntry)(&nNIKAL100_mInsertNamespace(nNIKAL100_namespaceMacro,_driver)))
      return -ENODEV;
   nNIKAL100_mInsertNamespace(nNIKAL100_namespaceMacro,_driver).module = THIS_MODULE;
   /* on fail registerDriver will call unregisterDriver which will
    * subsequently call driver->unload for us */
   return nNIKAL100_registerDriver(&nNIKAL100_mInsertNamespace(nNIKAL100_namespaceMacro,_driver));
}

void cleanup_module(void)
{
   /* unregisterDriver also calls driver->unlod for us */
   nNIKAL100_unregisterDriver(&(nNIKAL100_mInsertNamespace(nNIKAL100_namespaceMacro,_driver)));
}

