#!/bin/sh
#
#  uninstall.sh
#  Uninstall shell script to remove the NI-KAL kernel module from the system
#
#   Copyright 2002-2005,
#  National Instruments Corporation.
#  All Rights reserved.
#
#  originated:  28 October 2002
#

. Makefile.in
. ../bin/installerUtility.sh

removeKALModule()
{
   if [ -d $MODPATH/nikal ]; then
      $RM -f $MODPATH/nikal/nikal.$KERNEL_MODULE_EXTENSION
      $RMDIR -p --ignore-fail-on-non-empty $MODPATH/nikal
   fi
}

if [ `$ID -ur` != 0 ]; then
   echo "Please run NI-KAL kernel module uninstaller as root"
   exit 1
fi

if configuredForCurrentKernel; then
   echo -n "Uninstalling NI-KAL (nikal): "
   if testKernelDriverLoaded nikal; then
      recursiveUnloadKernelDriver nikal
   fi

   removeKALModule
   /sbin/depmod -a >/dev/null 2>&1
   echo "done"
else
   echo -n "Removing NI-KAL (nikal): "
   removeKALModule
   echo "done"
fi

exit 0

